VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DS1054Z FW 00.04.03.02 SP2 BUG TESTER"
   ClientHeight    =   5805
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10320
   LinkTopic       =   "Form1"
   ScaleHeight     =   5805
   ScaleWidth      =   10320
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "rigol bug test"
      Height          =   1095
      Left            =   6540
      TabIndex        =   0
      Top             =   4020
      Width           =   2745
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()
    bug_sequence
End Sub

Private Sub bug_sequence()
    Const bufSize As Long = 1024
    Dim buf As String
    
    Dim hWnd As Long
    Dim defrm As Long
    Dim nmatches As Long
    Dim matches As String
    Dim res As Long
    Dim list As Long
    Dim vi As Long

    Dim dat() As Byte
    Dim datPtr As Long
    Dim datsize As Long
    Dim j As Long

    Command1.Enabled = False

    'preparing buffer
    buf = String(bufSize, Chr(0))

    'connecting to scope
    matches = String(200, Chr(0))
    res = viOpenDefaultRM(defrm)
    res = viFindRsrc(defrm, "USB?*", list, nmatches, matches)
    res = viOpen(defrm, matches, 0, 0, vi)
    hWnd = vi

    'DS1054Z (FW 4.3.2.3 SP2) is switched on
    'ch1,2 setting = 10X, 10mV/div
    'ch1 offset = 30mV (0V signal at top screen)
    'ch2 offset = -30mV (0V signal at bottom screen)
    'time is 100ns/div mem depth auto, (500MSa/s, 600pts), acquisition peak
    'ch1,2 is not connected to any probe
    'trigger source is ch1 at 0V level

    'activate ch1,2
    viVPrintf hWnd, ":CHAN1:DISP ON" + Chr(10), 0
    viVPrintf hWnd, ":CHAN2:DISP ON" + Chr(10), 0

    'make sure not in stop state
    viVPrintf hWnd, ":TRIG:SWE NORMAL" + Chr(10), 0
    viVPrintf hWnd, ":RUN" + Chr(10), 0
    viVPrintf hWnd, ":TRIG:STAT?" + Chr(10), 0
    viVScanf hWnd, "%t", buf

    Do Until Left(buf, 4) <> "STOP"
        viVPrintf hWnd, ":TRIG:STAT?" + Chr(10), 0
        viVScanf hWnd, "%t", buf
    Loop

    'set memory for internal
    viVPrintf hWnd, ":ACQ:MDEP AUTO" + Chr(10), 0
    viVPrintf hWnd, ":WAV:MODE MAXIMUM" + Chr(10), 0

    'make single trigger
    viVPrintf hWnd, ":TRIG:SWE SINGLE" + Chr(10), 0

    'wait until we have trigger and stop, user must provide signal to scope for trigger
    Do Until Left(buf, 4) = "STOP"
        viVPrintf hWnd, ":TRIG:STAT?" + Chr(10), 0
        viVScanf hWnd, "%t", buf
    Loop

    'get internal memory size (should be 600)
    viVPrintf hWnd, ":WAV:PRE?" + Chr(10), 0
    viVScanf hWnd, "%t", buf
    j = InStr(5, buf, ",", vbBinaryCompare)
    datsize = CLng(Mid(buf, 5, j - 5))
    ReDim dat(datsize + 100)

    'copy ch1 internal memory
    datPtr = VarPtr(dat(0))
    dat(0) = 0

    viVPrintf hWnd, ":WAV:STOP " + CStr(datsize) + Chr(10), 0
    viVPrintf hWnd, ":WAV:SOUR CHAN1" + Chr(10), 0
    viVPrintf hWnd, ":WAV:DATA?" + Chr(10), 0

    'we receive dso memory to dat(). sometime
    'dat() will be filled with mixed (interleaved) data ch1 and 2 or garbage
    'to correct dat() output, we need to play around with dso run/stop/single
    'button and retry the code

    viVScanf hWnd, "%t", datPtr

    'close the scope
    viClose hWnd
    viClose defrm

    'save tmc header + signal (garbage) data to file
    ReDim Preserve dat(datsize + 10)
    Open "c:\rigol_data.tmp" For Binary Access Write As 1
    Put #1, , dat()
    Close 1

    'please analyze data in the file, sometime its garbage.
    Command1.Enabled = True
    Beep
End Sub

